/**
 * BSS Commerce Co.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the EULA
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://bsscommerce.com/Bss-Commerce-License.txt
 *
 * @category   BSS
 * @package    Bss_CustomOptionImageCustomize
 * @author     Extension Team
 * @copyright  Copyright (c) 2018-2019 BSS Commerce Co. ( http://bsscommerce.com )
 * @license    http://bsscommerce.com/Bss-Commerce-License.txt
 */
define([
    'jquery',
    'underscore',
    'mage/template',
    'priceUtils',
    'jquery/ui'
], function ($, _, mageTemplate, utils) {
    'use strict';
    $.widget('bss.bss_preview_checkbox', {
        _create: function () {
            var $widget = this,
                url = $widget.updateImage($widget);
            $widget.updateEventListener($widget, url);
        },
        updateEventListener: function ($widget, url) {
            var viewType = this.options.viewType,
                width = this.options.imageWidth,
                height = this.options.imageHeight;
            if (viewType == 0) {
                $widget.element.find('.product-custom-option.checkbox').each(function () {
                    if ($(this).is(":checked")) {
                        var optionId = $(this).val();
                        var html = $widget.getHtml($(this), optionId, url, width, height);
                        if (html != '') {
                            $(this).parent().addClass('bss-preview-checkbox');
                            $(this).parent().append(html);
                        }
                    }
                });
                $widget.element.find('.product-custom-option.checkbox').change(function () {
                    if ($(this).is(":checked")) {
                        if ($(this).parent('.field.choice').find('img').length == 0) {
                            var optionId = $(this).val();
                            var html = $widget.getHtml($(this), optionId, url, width, height);
                            if (html != '') {
                                $(this).parent().append(html);
                            }
                        }
                        if ($(this).parent('.field.choice').find('img').length > 0) {
                            $(this).parent().addClass('bss-preview-checkbox');
                            $(this).parent('.field.choice').find('img').show();
                        }
                    } else {
                        if ($(this).parent('.field.choice').find('img').length > 0) {
                            $(this).parent('.field.choice').find('img').hide();
                            $(this).parent().removeClass('bss-preview-checkbox');
                        }
                    }

                });
            }
            if (viewType == 1) {
                $widget.element.find('.product-custom-option.checkbox').each(function () {
                    var optionId = $(this).val();
                    var html = $widget.getHtml($(this), optionId, url, width, height);
                    if (html != '') {
                        $(this).parent().addClass('bss-preview-checkbox');
                        $(this).parent().append(html);
                    }
                })
            }

        },

        getHtml: function (selector, optionId, url, width, height) {
            var html = '';
            if (url[optionId].length > 0) {
                html += '<img alt="'+
                    $.trim(selector.parent().find('label span:first-child').html()) +
                    '" src="' +
                    url[optionId] +
                    '" title="' +
                    $.trim(selector.parent().find('label span:first-child').html()) +
                    '" style="height: ' +
                    height +
                    'px; width: ' +
                    width +
                    'px; border: solid 1px #ddd;" />';
            }
            return html;
        },

        updateImage: function ($widget) {
            var result = [];
            $.each($widget.options.imageUrls, function (index, value) {
                result[value.id] = value.url;
            });
            return result;
        }
    });
    return $.bss.bss_preview_checkbox;
});