<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_NameYourPrice
 * @copyright   Copyright (c) Mageplaza (https://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\NameYourPrice\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

/**
 * Interface BargainManagementInterface
 * @package Mageplaza\NameYourPrice\Api
 */
interface BargainManagementInterface
{
    /**
     * @param SearchCriteriaInterface $searchCriteria
     *
     * @return \Mageplaza\NameYourPrice\Api\Data\BargainSearchResultInterface
     */
    public function getList(SearchCriteriaInterface $searchCriteria = null);

    /**
     * @param string $id
     *
     * @return bool
     */
    public function approve($id);

    /**
     * @param string $id
     *
     * @return bool
     */
    public function reject($id);

    /**
     * @param \Mageplaza\NameYourPrice\Api\Data\BargainInterface $bargain
     *
     * @return \Mageplaza\NameYourPrice\Api\Data\BargainInterface
     */
    public function saveGuest(\Mageplaza\NameYourPrice\Api\Data\BargainInterface $bargain);

    /**
     * @param string $customerId
     *
     * @return \Mageplaza\NameYourPrice\Api\Data\BargainInterface[]
     */
    public function getMine($customerId);

    /**
     * @param string $customerId
     * @param \Mageplaza\NameYourPrice\Api\Data\BargainInterface $bargain
     *
     * @return \Mageplaza\NameYourPrice\Api\Data\BargainInterface
     */
    public function saveMine($customerId, \Mageplaza\NameYourPrice\Api\Data\BargainInterface $bargain);

    /**
     * @param string $customerId
     * @param string $id
     *
     * @return bool
     */
    public function cancelMine($customerId, $id);
}
