<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_NameYourPrice
 * @copyright   Copyright (c) Mageplaza (https://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\NameYourPrice\Api\Data;

/**
 * Interface BargainInterface
 * @package Mageplaza\NameYourPrice\Api\Data
 */
interface BargainInterface
{
    /**
     * Constants defined for keys of array, makes typos less likely
     */
    const REQUEST_ID           = 'request_id';
    const PRODUCT_ID           = 'product_id';
    const PRODUCT_NAME         = 'product_name';
    const SKU                  = 'sku';
    const OPTIONS_CONFIGURABLE = 'options_configurable';
    const ORIGINAL_PRICE       = 'original_price';
    const BARGAIN_PRICE        = 'bargain_price';
    const BARGAIN_QTY          = 'bargain_qty';
    const STATUS               = 'status';
    const CUSTOMER_NAME        = 'customer_name';
    const PHONE                = 'phone';
    const CUSTOMER_EMAIL       = 'customer_email';
    const STORE_IDS            = 'store_ids';
    const CUSTOMER_MESSAGE     = 'customer_message';
    const ADMIN_MESSAGE        = 'admin_message';
    const SUBMITTED_DATE       = 'submitted_date';
    const TIME_USE             = 'time_use';
    const OPTIONS_BUNDLE       = 'options_bundle';
    const PARENT_ID            = 'parent_id';

    /**
     * @return int
     */
    public function getRequestId();

    /**
     * @param int $value
     *
     * @return $this
     */
    public function setRequestId($value);

    /**
     * @return int
     */
    public function getProductId();

    /**
     * @param int $value
     *
     * @return $this
     */
    public function setProductId($value);

    /**
     * @return string
     */
    public function getProductName();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setProductName($value);

    /**
     * @return string
     */
    public function getSku();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setSku($value);

    /**
     * @return string
     */
    public function getOptionsConfigurable();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setOptionsConfigurable($value);

    /**
     * @return float
     */
    public function getOriginalPrice();

    /**
     * @param float $value
     *
     * @return $this
     */
    public function setOriginalPrice($value);

    /**
     * @return float
     */
    public function getBargainPrice();

    /**
     * @param float $value
     *
     * @return $this
     */
    public function setBargainPrice($value);

    /**
     * @return int
     */
    public function getBargainQty();

    /**
     * @param int $value
     *
     * @return $this
     */
    public function setBargainQty($value);

    /**
     * @return string
     */
    public function getStatus();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setStatus($value);

    /**
     * @return string
     */
    public function getCustomerName();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setCustomerName($value);

    /**
     * @return string
     */
    public function getPhone();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setPhone($value);

    /**
     * @return string
     */
    public function getCustomerEmail();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setCustomerEmail($value);

    /**
     * @return string
     */
    public function getStoreIds();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setStoreIds($value);

    /**
     * @return string
     */
    public function getCustomerMessage();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setCustomerMessage($value);

    /**
     * @return string
     */
    public function getAdminMessage();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setAdminMessage($value);

    /**
     * @return string
     */
    public function getSubmittedDate();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setSubmittedDate($value);

    /**
     * @return string
     */
    public function getTimeUse();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setTimeUse($value);

    /**
     * @return string
     */
    public function getOptionsBundle();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setOptionsBundle($value);

    /**
     * @return int
     */
    public function getParentId();

    /**
     * @param int $value
     *
     * @return $this
     */
    public function setParentId($value);
}
