<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_NameYourPrice
 * @copyright   Copyright (c) Mageplaza (https://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\NameYourPrice\Api\Data;

/**
 * Interface EmailConfigInterface
 * @package Mageplaza\NameYourPrice\Api\Data
 */
interface EmailConfigInterface
{
    /**
     * @return boolean
     */
    public function getEnabled();

    /**
     * @param boolean $value
     *
     * @return $this
     */
    public function setEnabled($value);

    /**
     * @return string
     */
    public function getSender();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setSender($value);

    /**
     * @return string
     */
    public function getAdminEmail();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setAdminEmail($value);

    /**
     * @return string
     */
    public function getTemplateConfirm();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setTemplateConfirm($value);

    /**
     * @return string
     */
    public function getTemplateApprove();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setTemplateApprove($value);

    /**
     * @return string
     */
    public function getTemplateReject();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setTemplateReject($value);
}
