<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_NameYourPrice
 * @copyright   Copyright (c) Mageplaza (https://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\NameYourPrice\Api\Data;

/**
 * Interface GeneralConfigInterface
 * @package Mageplaza\NameYourPrice\Api\Data
 */
interface GeneralConfigInterface
{
    /**
     * @return boolean
     */
    public function getEnabled();

    /**
     * @param boolean $value
     *
     * @return $this
     */
    public function setEnabled($value);

    /**
     * @return string
     */
    public function getCustomerGroups();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setCustomerGroups($value);

    /**
     * @return string
     */
    public function getCondition();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setCondition($value);

    /**
     * @return string
     */
    public function getPriceType();

    /**
     * @param string $value
     *
     * @return $this
     */
    public function setPriceType($value);

    /**
     * @return float
     */
    public function getPriceValue();

    /**
     * @param float $value
     *
     * @return $this
     */
    public function setPriceValue($value);

    /**
     * @return boolean
     */
    public function getIsTax();

    /**
     * @param boolean $value
     *
     * @return $this
     */
    public function setIsTax($value);

    /**
     * @return boolean
     */
    public function getAllowDiscount();

    /**
     * @param boolean $value
     *
     * @return $this
     */
    public function setAllowDiscount($value);

    /**
     * @return int
     */
    public function getLimitTime();

    /**
     * @param int $value
     *
     * @return $this
     */
    public function setLimitTime($value);

    /**
     * @return boolean
     */
    public function getBargainQty();

    /**
     * @param boolean $value
     *
     * @return $this
     */
    public function setBargainQty($value);

    /**
     * @return boolean
     */
    public function getApplyCustomOption();

    /**
     * @param boolean $value
     *
     * @return $this
     */
    public function setApplyCustomOption($value);
}
