<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_NameYourPrice
 * @copyright   Copyright (c) Mageplaza (https://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\NameYourPrice\Model;

use Magento\Framework\Model\AbstractModel;
use Mageplaza\NameYourPrice\Api\Data\BargainInterface;
use Mageplaza\NameYourPrice\Model\ResourceModel\Requests as ResourceRequests;

/**
 * Class Requests
 * @package Mageplaza\NameYourPrice\Model
 */
class Requests extends AbstractModel implements BargainInterface
{
    /**
     * Event prefix
     *
     * @var string
     */
    protected $_eventPrefix = 'mageplaza_mppricebargain_requests';

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init(ResourceRequests::class);
    }

    /**
     * @inheritDoc
     */
    public function getRequestId()
    {
        return $this->getData(self::REQUEST_ID);
    }

    /**
     * @inheritDoc
     */
    public function setRequestId($value)
    {
        return $this->setData(self::REQUEST_ID, $value);
    }

    /**
     * @inheritDoc
     */
    public function getProductId()
    {
        return $this->getData(self::PRODUCT_ID);
    }

    /**
     * @inheritDoc
     */
    public function setProductId($value)
    {
        return $this->setData(self::PRODUCT_ID, $value);
    }

    /**
     * @inheritDoc
     */
    public function getProductName()
    {
        return $this->getData(self::PRODUCT_NAME);
    }

    /**
     * @inheritDoc
     */
    public function setProductName($value)
    {
        return $this->setData(self::PRODUCT_NAME, $value);
    }

    /**
     * @inheritDoc
     */
    public function getSku()
    {
        return $this->getData(self::SKU);
    }

    /**
     * @inheritDoc
     */
    public function setSku($value)
    {
        return $this->setData(self::SKU, $value);
    }

    /**
     * @inheritDoc
     */
    public function getOptionsConfigurable()
    {
        return $this->getData(self::OPTIONS_CONFIGURABLE);
    }

    /**
     * @inheritDoc
     */
    public function setOptionsConfigurable($value)
    {
        return $this->setData(self::OPTIONS_CONFIGURABLE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getOriginalPrice()
    {
        return $this->getData(self::ORIGINAL_PRICE);
    }

    /**
     * @inheritDoc
     */
    public function setOriginalPrice($value)
    {
        return $this->setData(self::ORIGINAL_PRICE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getBargainPrice()
    {
        return $this->getData(self::BARGAIN_PRICE);
    }

    /**
     * @inheritDoc
     */
    public function setBargainPrice($value)
    {
        return $this->setData(self::BARGAIN_PRICE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getBargainQty()
    {
        return $this->getData(self::BARGAIN_QTY);
    }

    /**
     * @inheritDoc
     */
    public function setBargainQty($value)
    {
        return $this->setData(self::BARGAIN_QTY, $value);
    }

    /**
     * @inheritDoc
     */
    public function getStatus()
    {
        return $this->getData(self::STATUS);
    }

    /**
     * @inheritDoc
     */
    public function setStatus($value)
    {
        return $this->setData(self::STATUS, $value);
    }

    /**
     * @inheritDoc
     */
    public function getCustomerName()
    {
        return $this->getData(self::CUSTOMER_NAME);
    }

    /**
     * @inheritDoc
     */
    public function setCustomerName($value)
    {
        return $this->setData(self::CUSTOMER_NAME, $value);
    }

    /**
     * @inheritDoc
     */
    public function getPhone()
    {
        return $this->getData(self::PHONE);
    }

    /**
     * @inheritDoc
     */
    public function setPhone($value)
    {
        return $this->setData(self::PHONE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getCustomerEmail()
    {
        return $this->getData(self::CUSTOMER_EMAIL);
    }

    /**
     * @inheritDoc
     */
    public function setCustomerEmail($value)
    {
        return $this->setData(self::CUSTOMER_EMAIL, $value);
    }

    /**
     * @inheritDoc
     */
    public function getStoreIds()
    {
        return $this->getData(self::STORE_IDS);
    }

    /**
     * @inheritDoc
     */
    public function setStoreIds($value)
    {
        return $this->setData(self::STORE_IDS, $value);
    }

    /**
     * @inheritDoc
     */
    public function getCustomerMessage()
    {
        return $this->getData(self::CUSTOMER_MESSAGE);
    }

    /**
     * @inheritDoc
     */
    public function setCustomerMessage($value)
    {
        return $this->setData(self::CUSTOMER_MESSAGE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getAdminMessage()
    {
        return $this->getData(self::ADMIN_MESSAGE);
    }

    /**
     * @inheritDoc
     */
    public function setAdminMessage($value)
    {
        return $this->setData(self::ADMIN_MESSAGE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getSubmittedDate()
    {
        return $this->getData(self::SUBMITTED_DATE);
    }

    /**
     * @inheritDoc
     */
    public function setSubmittedDate($value)
    {
        return $this->setData(self::SUBMITTED_DATE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getTimeUse()
    {
        return $this->getData(self::TIME_USE);
    }

    /**
     * @inheritDoc
     */
    public function setTimeUse($value)
    {
        return $this->setData(self::TIME_USE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getOptionsBundle()
    {
        return $this->getData(self::OPTIONS_BUNDLE);
    }

    /**
     * @inheritDoc
     */
    public function setOptionsBundle($value)
    {
        return $this->setData(self::OPTIONS_BUNDLE, $value);
    }

    /**
     * @inheritDoc
     */
    public function getParentId()
    {
        return $this->getData(self::PARENT_ID);
    }

    /**
     * @inheritDoc
     */
    public function setParentId($value)
    {
        return $this->setData(self::PARENT_ID, $value);
    }
}
