<?php
/**
 * Copyright © 2015 Cisin. All rights reserved.
 */

// @codingStandardsIgnoreFile

namespace Cisin\Slider\Block\Adminhtml\Items\Edit\Tab;


use Magento\Backend\Block\Widget\Form\Generic;
use Magento\Backend\Block\Widget\Tab\TabInterface;
// use Magento\Framework\Option\ArrayInterface;

use Magento\Backend\Block\Template\Context;
// use Magento\Backend\Block\Widget\Form\Generic;
// use Magento\Backend\Block\Widget\Tab\TabInterface;
use Magento\Backend\Model\Auth\Session;
use Magento\Cms\Model\Wysiwyg\Config;
use Magento\Config\Model\Config\Source\Design\Robots;
use Magento\Config\Model\Config\Source\Enabledisable;
use Magento\Config\Model\Config\Source\Yesno;
use Magento\Framework\Data\FormFactory;
use Magento\Framework\Registry;
use Magento\Store\Model\System\Store;
use \Cisin\Slider\Helper\Data;




class Main extends Generic implements TabInterface
{

 public function __construct(
        Context $context,
        Registry $registry,
        Session $authSession,
        FormFactory $formFactory,
        Config $wysiwygConfig,
        Yesno $booleanOptions,
        Enabledisable $enableDisable,
        Robots $metaRobotsOptions,
        Store $systemStore,
        Data $helper,
        array $data = []
    )
    {
        $this->wysiwygConfig     = $wysiwygConfig;
        $this->booleanOptions    = $booleanOptions;
        $this->enabledisable     = $enableDisable;
        $this->metaRobotsOptions = $metaRobotsOptions;
        $this->systemStore       = $systemStore;
        $this->authSession       = $authSession;
         $this->helper = $helper;

        parent::__construct($context, $registry, $formFactory, $data);
    }

/**
     * Core registry
     *
     * @var \Magento\Framework\Registry
     */
    protected $_coreRegistry;

    /**
     * @var \Magento\Backend\Model\View\Result\ForwardFactory
     */
    protected $resultForwardFactory;

    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $resultPageFactory;
    /**
     * {@inheritdoc}
     */
    // public function __construct(){  }
    
    public function getTabLabel()
    {
        return __('Blog Information');
    }

    /**
     * {@inheritdoc}
     */
    public function getTabTitle()
    {
        return __('Blog Information');
    }

    /**
     * {@inheritdoc}
     */
    public function canShowTab()
    {
        return true;
    }

    /**
     * {@inheritdoc}
     */
    public function isHidden()
    {
        return false;
    }

    /**
     * Prepare form before rendering HTML
     *
     * @return $this
     * @SuppressWarnings(PHPMD.NPathComplexity)
     * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
     */
    protected function _prepareForm()
    {
        $model = $this->_coreRegistry->registry('current_cisin_slider_items');
        /** @var \Magento\Framework\Data\Form $form */
        $form = $this->_formFactory->create([
        'data' => [
                   'id' => 'edit_form',
                   'action' => $this->getData('action'),
                   'method' => 'post',
                   'enctype' => 'multipart/form-data'
                  ]
        ]);
        
        $form->setHtmlIdPrefix('item_');
        $fieldset = $form->addFieldset('base_fieldset', ['legend' => __('Item Information')]);
        if ($model->getId()) {
            $fieldset->addField('id', 'hidden', ['name' => 'id']);
        }
        $fieldset->addField(
            'title',
            'text',
            ['name' => 'title', 'label' => __('Title'), 'title' => __('Title'), 'required' => true]
        );
        $fieldset->addField(
            'sortOrder',
            'text',
            ['name' => 'sortOrder', 'label' => __('sortOrder'), 'title' => __('sortOrder'), 'required' => false]
        );
        $fieldset->addField(
            'image',
            'image',
            ['name' => 'image', 'label' => __('Image'), 'title' => __('image'), 'required' => false]
        );
        // $fieldset->addField(
        //     'text',
        //     'textarea',
        //     ['name' => 'text', 'label' => __('Text'), 'title' => __('text'), 'required' => true]
        // );
        $fieldset->addField('text', 'editor', [
                'name'   => 'text',
                'label'  => __('Content'),
                'title'  => __('Content'),
                'config' => $this->wysiwygConfig->getConfig()
            ]
        );
        $fieldset->addField(
            'status',
            'select',
            ['name' => 'status', 'label' => __('status'), 'title' => __('status'), 'options' => [
                    ''=> __('Default'),
                    '0' => __('No'),
                    '1' => __('Yes'),
                ],'required' => true]
        );

        $fieldset->addField(
               'category',
               'multiselect',
               [
                 'name'     => 'category',
                 'label'    => __('Category'),
                 'title'    => __('Category'),
                 'required' => true,
                'values' => $this->helper->toOptionArray()
               ]
            );
        // $fieldset->addField('category', '\Cisin\Slider\Block\Adminhtml\Items\Edit\Tab\Renderer\Category', [
        //         'name'  => 'category',
        //         'label' => __('Categories'),
        //         'title' => __('Categories'),
        //     ]
        // );
        // if (!$post->getCategoriesIds()) {
        //     $post->setCategoriesIds($post->getCategoryIds());
        // }

        $form->setValues($model->getData());
        $this->setForm($form);
        return parent::_prepareForm();
    }
}
