<?php
namespace Cisin\Salesordergrid\Observer;
 
use Magento\Framework\Event\ObserverInterface;
 
class SetItemDropdownAttribute implements ObserverInterface
{
    /**
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {

        $quoteItem = $observer->getQuoteItem();
        $product = $observer->getProduct();
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $product = $objectManager->create('Magento\Catalog\Model\Product')->load($quoteItem->getProductId());

        $data = explode(',',$product->getData('product_brand'));
         if(count($data)){
            $attr = $product->getResource()->getAttribute('product_brand');
            $optionText = $attr->getSource()->getOptionText($data[0]);
            $supplier_value=$optionText;//$data[0];
            //$supplier_value=$data[0];
        }else{
            $supplier_value='';
        }
        $quoteItem->setProductBrand($supplier_value);
        $product_brand=$product->getResource()->getAttribute('brand')->getFrontend()->getValue($product);
        $quoteItem->setProductSupplier($product_brand);
        $quoteItem->setBrand($product_brand);

    }
}