<?php

namespace Cisin\Salesordergrid\Ui\Component\Listing\Column;


use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Framework\View\Element\UiComponent\ContextInterface;

/**
 * @api
 * @since 100.0.2
 */
class Reviewstatus extends \Magento\Ui\Component\Listing\Columns\Column
{
   

    /**
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param \Magento\Framework\Locale\CurrencyInterface $localeCurrency
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param array $components
     * @param array $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
        $this->storeManager = $storeManager;
    }

    /**
     * Prepare Data Source
     *
     * @param array $dataSource
     * @return array
     */

    public function prepareDataSource(array $dataSource) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        if (isset($dataSource['data']['items'])) {
            $fieldName = 'entity_id';//$this->getData('name');
            foreach ($dataSource['data']['items'] as & $item) {
                    $order = $objectManager->create('Magento\Sales\Model\Order')->load($item['entity_id']);
                     $delmethod = $order->getReviewStatus();
                     
                     if($delmethod=="1"){
                        $delmethods='Yes';
                     }
                     else if($delmethod=='2'){
                        $delmethods='No';
                     }
                     else{
                        $delmethods='';
                     }
            

            
                     
                //$item['yourcolumn'] is column name
                $item['review_status'] =$delmethods; //Here you can do anything with actual data

            }
        }

        return $dataSource;
    }
    
}
