<?php

namespace Cisin\Salesordergrid\Ui\Component\Listing\Column;


use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Framework\View\Element\UiComponent\ContextInterface;

/**
 * @api
 * @since 100.0.2
 */
class ShippingInformation extends \Magento\Ui\Component\Listing\Columns\Column
{


    /**
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param \Magento\Framework\Locale\CurrencyInterface $localeCurrency
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param array $components
     * @param array $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
        $this->storeManager = $storeManager;
    }

    /**
     * Prepare Data Source
     *
     * @param array $dataSource
     * @return array
     */

    public function prepareDataSource(array $dataSource) {
        if (isset($dataSource['data']['items'])) {  

            foreach ($dataSource['data']['items'] as & $item) {
                $method = null;  
                if($item['shipping_information'] == 'Click & Collect - Fixed'){                    
                    $method = 'Click & Collect';
                }else{
                    $method = $item['shipping_information'];
                }
                $item['shipping_information'] = $method;
            }
        }

        return $dataSource;
    }

}
