<?php

namespace MagePsycho\MassImporterPro\Block\Adminhtml\Import\Edit\Renderer;

use Magento\Framework\Data\Form\Element\Renderer\RendererInterface;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Uploader extends \Magento\Backend\Block\Widget implements RendererInterface
{
    public function render(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        $uploadMessage = __(sprintf('Your server PHP settings allow you to upload files not more than %s at a time.', ini_get('upload_max_filesize')));
        $html = '
<div class="admin__field field field-import_file required _required" data-ui-id="import-form-container-form-fieldset-element-form-field-import-file">
    <label class="label admin__field-label" for="import_file" data-ui-id="import-form-container-form-fieldset-element-select-import-file-label"><span>Select File to Import</span></label>
    <div class="admin__field-control control">
        <div id="mip-messages"><div class="messages"><div class="message message-notice notice"><div data-ui-id="messages-message-notice">' . $uploadMessage . '</div></div></div></div>
        <div class="upload-wrapper mip-custom-uploader" data-bind="scope: \'mip_uploader\'">
            <!-- ko template: getTemplate() --><!-- /ko -->
        </div>
        <div style="clear:both;">
            <input type="text" id="validate_upload_field" name="validate_upload_field" class="required-entry" data-msg="Please upload import file." style="border: #fff; position: absolute; top: 0; left: 0; z-index: -1;" />
        </div>
    </div>
</div>';
        return $html;
    }
}
