<?php

namespace MagePsycho\MassImporterPro\Model\Source\Import\Behavior;

/**
 * Import behavior source model used for defining the behaviour during the import.
 *
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Basic extends \MagePsycho\MassImporterPro\Model\Source\Import\AbstractBehavior
{
    /**
     * {@inheritdoc}
     */
    public function toArray()
    {
        return [
            \MagePsycho\MassImporterPro\Model\Import::BEHAVIOR_APPEND => __('Add/Update'),
            \MagePsycho\MassImporterPro\Model\Import::BEHAVIOR_REPLACE => __('Replace'),
            \MagePsycho\MassImporterPro\Model\Import::BEHAVIOR_DELETE => __('Delete')
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function getCode()
    {
        return 'basic';
    }

    /**
     * {@inheritdoc}
     */
    public function getNotes($entityCode)
    {
        $messages = ['catalog_product' => [
            \MagePsycho\MassImporterPro\Model\Import::BEHAVIOR_REPLACE => __("Note: Product IDs will be regenerated.")
        ]];
        return isset($messages[$entityCode]) ? $messages[$entityCode] : [];
    }
}
