<?php

namespace MagePsycho\MassImporterPro\Model\System\Config\Source;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MassImporterPro
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class EntityType implements \Magento\Framework\Option\ArrayInterface
{
    protected $_options;

    /**
     * @var
     */
    protected $entityTypes;

    public function __construct(
        array $entityTypes
    ) {
        $this->entityTypes = $entityTypes;
    }

    public function getAllOptions($withEmpty = false)
    {
        if ($this->_options === null) {
            foreach ($this->entityTypes as $key => $label) {
                $this->_options[] = [
                    'value' => $key,
                    'label' => __($label),
                ];
            }
        }
        $options = $this->_options;
        if ($withEmpty) {
            array_unshift($options, ['value' => '', 'label' => '']);
        }
        return $options;
    }

    public function getOptionsArray($withEmpty = true)
    {
        $options = [];
        foreach ($this->getAllOptions($withEmpty) as $option) {
            $options[$option['value']] = $option['label'];
        }
        return $options;
    }

    public function getOptionText($value)
    {
        $options = $this->getAllOptions(false);
        foreach ($options as $item) {
            if ($item['value'] == $value) {
                return $item['label'];
            }
        }
        return false;
    }

    public function toOptionArray()
    {
        return $this->getAllOptions();
    }

    public function toOptionHash($withEmpty = true)
    {
        return $this->getOptionsArray($withEmpty);
    }
}
