<?php

namespace MagePsycho\MipPricing\Plugin\Model\Export\Entity;

use MagePsycho\MipPricing\Model\Config\ModuleMetadata;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MipPricing
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class ExportInfoFactory
{
    /**
     * @var \Magento\Framework\App\RequestInterface
     */
    private $request;

    /**
     * @var ModuleMetadata
     */
    private $moduleMetadata;

    public function __construct(
        ModuleMetadata $moduleMetadata,
        \Magento\Framework\App\RequestInterface $request
    ) {
        $this->request = $request;
        $this->moduleMetadata = $moduleMetadata;
    }

    public function beforeCreate(
        \Magento\ImportExport\Model\Export\Entity\ExportInfoFactory $subject,
        $fileFormat,
        $entity,
        $exportFilter,
        $skipAttr = []
    ) {
        if ($entity == 'mip_pricing') {
            $exportFilter = array_merge(
                $exportFilter,
                [
                    'mip_website_id' => $this->request->getParam('mip_website_id'),
                    'mip_pricing_attributes' => $this->request->getParam('mip_pricing_attributes')
                ]
            );
        }
        if (version_compare($this->moduleMetadata->getMageVersion(), '2.3.4', '>=')) {
            return [$fileFormat, $entity, $exportFilter, $skipAttr];
        } else {
            return [$fileFormat, $entity, $exportFilter];
        }
    }
}
