<?php

namespace MagePsycho\MipPricing\Plugin\Model\Import;

use MagePsycho\MipPricing\Model\Import\Pricing as MipPricing;

/**
 * @category   MagePsycho
 * @package    MagePsycho_MipPricing
 * @author     Raj KB <magepsycho@gmail.com>
 * @website    https://www.magepsycho.com
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
class Pricing
{
    /**
     * @var \MagePsycho\MipPricing\Helper\Data
     */
    private $mipPricingHelper;

    /**
     * @var \Magento\Framework\Indexer\IndexerRegistry
     */
    private $indexerRegistry;

    public function __construct(
        \MagePsycho\MipPricing\Helper\Data $mipPricingHelper,
        \Magento\Framework\Indexer\IndexerRegistry $indexerRegistry
    ) {
        $this->mipPricingHelper = $mipPricingHelper;
        $this->indexerRegistry  = $indexerRegistry;
    }

    public function afterSavePricing(MipPricing $subject)
    {
        $this->invalidateIndexer();
    }

    public function afterReplacePricing(MipPricing $subject)
    {
        $this->invalidateIndexer();
    }

    public function afterDeletePricing(MipPricing $subject)
    {
        $this->invalidateIndexer();
    }

    /**
     * Invalidate indexer
     *
     * @return void
     */
    private function invalidateIndexer()
    {
        $priceIndexer = $this->indexerRegistry->get(\Magento\Catalog\Model\Indexer\Product\Price\Processor::INDEXER_ID);
        if (!$priceIndexer->isScheduled()) {
            $priceIndexer->invalidate();
        }
    }
}
