<?php
/**
 * Copyright © MageWorx. All rights reserved.
 * See https://www.mageworx.com/terms-and-conditions for license details.
 */
declare(strict_types=1);

namespace MageWorx\OptionLink\Model;

use Magento\Catalog\Model\ResourceModel\Product as ProductResource;

class OptionValueSkuVlidator
{
    /**
     * @var ProductResource
     */
    protected $productResource;

    /**
     * SkuVlidator constructor.
     *
     * @param ProductResource $productResource
     */
    public function __construct(
        ProductResource $productResource
    ) {
        $this->productResource = $productResource;
    }

    /**
     * @param $sku
     * @return bool
     */
    public function isOptionValueSkuIsValid($sku): bool
    {
        return $this->productResource->getIdBySku($sku) ? true : false;
    }
}