<?php
/**
 *
 * Copyright © 2015 Cisincommerce. All rights reserved.
 */
namespace Nexus\BookAppointment\Controller\Book;
use Magento\Framework\App\Helper\Context;
use Magento\Framework\Mail\Template\TransportBuilder;
use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\Translate\Inline\StateInterface;
use Magento\Store\Model\StoreManagerInterface;
use Magento\Framework\Controller\ResultFactory; 


class Booknow extends \Magento\Framework\App\Action\Action 
{

	protected $transportBuilder;
    protected $storeManager;
    protected $inlineTranslation; 
    protected $resultPageFactory;

    public function __construct(
       \Magento\Framework\App\Action\Context $context,
        TransportBuilder $transportBuilder,
        StoreManagerInterface $storeManager,
        StateInterface $state
    ) {
        parent::__construct($context);
        $this->transportBuilder = $transportBuilder;
        $this->storeManager = $storeManager;
        $this->inlineTranslation = $state;
    }
	
    /**
     * Flush cache storage
     *
     */
    public function execute()
    {
        $data=$this->getRequest()->getParams();
        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT); 
        try {

            $pname=$data['pname'];
            $sku=$data['sku'];
            $fname=$data['fname'];  
            $email=$data['email'];
            $full_phone=$data['full_phone'];
            $postcode=$data['postcode'];
            $details=$data['details'];
            // template variables pass here
            $templateVars = [
                'pname' => $pname,
                'psku' => $sku,
                'fname' => $fname ,
                'email' => $email,
                'mobile' => $full_phone ,
                'postcode' => $postcode ,
                'details' => $details,
                'date' => date("d-m-Y h:i:s")
            ];
            $templateVars2 = [
                'pname' => $pname,
                'psku' => $sku,
                'fname' => "Team" ,
                'email' => $email,
                'customer_name' => $fname,
                'mobile' => $full_phone ,
                'postcode' => $postcode ,
                'details' => $details,
                'date' => date("d-m-Y h:i:s")
            ];

            $storeId = $this->storeManager->getStore()->getId();

            $from = ['email' => "info@nexus-home.com", 'name' => "Nexus Home"];
            //******************send email to customer ***********************************/
            $this->inlineTranslation->suspend();

            $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
            $templateOptions = [
                'area' => \Magento\Framework\App\Area::AREA_FRONTEND,
                'store' => $storeId
            ];
            $templateId = "24";
            $transport = $this->transportBuilder->setTemplateIdentifier($templateId)
                ->setTemplateOptions($templateOptions)
                ->setTemplateVars($templateVars)
                ->setFrom($from)
                ->addTo($email)                
                ->getTransport();
            $transport->sendMessage();
            $this->inlineTranslation->resume();
            //******************send email to admin ***********************************/
             $this->inlineTranslation->suspend();

            $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
            $templateOptions = [
                'area' => \Magento\Framework\App\Area::AREA_FRONTEND,
                'store' => $storeId
            ];
            $templateId = "23";
            $transport2 = $this->transportBuilder->setTemplateIdentifier($templateId)
                ->setTemplateOptions($templateOptions)
                ->setTemplateVars($templateVars2)
                ->setFrom($from)
                ->addTo("sales@nexus-home.com")
                ->setReplyTo($email)
                ->getTransport();
            $transport2->sendMessage();
            $this->inlineTranslation->resume();
            /*****************************************************************************/
            $this->messageManager->addSuccess(__('Thank You For Your Booking Appointment'));
            $resultRedirect->setUrl('/appointment/book/success');
        } catch (\Exception $e) {
            //$this->_logger->info($e->getMessage());
            $this->messageManager->addError(__('Sorry Booking Appointment is not sent'));
            $resultRedirect->setUrl($this->_redirect->getRefererUrl());
        }

       
        return $resultRedirect;
        
    }
}
