<?php

namespace OuterEdge\BulkActions\Controller\Adminhtml\Order;

use Magento\Sales\Model\Order;
use Magento\Backend\App\Action\Context;
use Magento\Sales\Model\OrderFactory as ModelOrder;
use Magento\Sales\Model\Convert\OrderFactory as ConvertOrder;
use Magento\Framework\Message\ManagerInterface;
use Magento\Shipping\Model\ShipmentNotifier;
use Magento\Framework\DB\TransactionFactory;

class MassOrderShip extends \Magento\Backend\App\Action
{
    /**
     * @var ModelOrder
     */
    protected $orderModel;

    /**
     * @var Order
     */
    protected $convertOrder;

    /**
     * @var ManagerInterface
     */
    protected $messageManager;

    /**
     * @var ShipmentNotifier
     */
    protected $shipmentNotifier;

    /**
     * @var \Magento\Framework\DB\TransactionFactory
     */
    protected $transactionFactory;

    /**
     * Preparation constructor.
     * @param Context $context
     * @param ManagerInterface $messageManager
     * @param ModelOrder $orderModel
     * @param ConvertOrder $convertOrder
     * @param ShipmentNotifier $shipmentNotifier
     * @param TransactionFactory $transactionFactory
     */
    public function __construct(
        Context $context,
        ManagerInterface $messageManager,
        ModelOrder $orderModel,
        ConvertOrder $convertOrder,
        ShipmentNotifier $shipmentNotifier,
        TransactionFactory $transactionFactory
    ) {
        parent::__construct($context);

        $this->messageManager = $messageManager;
        $this->orderModel = $orderModel;
        $this->convertOrder = $convertOrder;
        $this->shipmentNotifier = $shipmentNotifier;
        $this->transactionFactory = $transactionFactory;
    }

    public function execute()
    {
        $ordersId = $this->getRequest()->getParam('selected');
        $complete = $this->getRequest()->getParam('complete');
        $readyfordelivery = $this->getRequest()->getParam('ready_for');

        // echo $pendingpayment; die;


        // echo $complete; die;
       if($complete ==1){
        $resultRedirect = $this->resultRedirectFactory->create();
        foreach ($ordersId as $value) {
           $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $order = $objectManager->create('\Magento\Sales\Model\Order') ->load($value);
            $orderState = Order::STATE_COMPLETE;
            $order->setState($orderState)->setStatus(Order::STATE_COMPLETE);
            $order->save();
        }
        return $resultRedirect->setPath('sales/order/index', [], ['error' => true]);
       }

       if($readyfordelivery ==1){
        $resultRedirect = $this->resultRedirectFactory->create();
        foreach ($ordersId as $value) {
           $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $order = $objectManager->create('\Magento\Sales\Model\Order') ->load($value);
            $orderState = Order::STATE_PROCESSING;
            $order->setState($orderState);
            $code = 'Out_for_Delivery';
            $order->setStatus($code);
            $order->save();
        }
        return $resultRedirect->setPath('sales/order/index', [], ['error' => true]);
       }
        
    }
}